package org.processmining.plugins.ppm;

import java.awt.GridLayout;

import javax.swing.JPanel;
import javax.swing.JSlider;

import org.deckfour.xes.model.XLog;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.plugins.ppm.ppmchart.PPMChartAnalysis;
import org.processmining.plugins.ppm.ppmchart.model.PPMChartModel;
import org.processmining.plugins.ppm.ppmchart.ui.ChunkPanel;
import org.processmining.plugins.ppm.ppmchart.ui.FilterPanel;
import org.processmining.plugins.ppm.ppmchart.ui.PPMChartOptionPanel;

public class ExportPPMParametersPanel extends JPanel {
	private static final long serialVersionUID = 0;
	
	PPMChartOptionPanel ppmcop;
	FilterPanel fp;
	ChunkPanel cp;

	public ExportPPMParametersPanel(PluginContext context, XLog log) {
		this.init(context, log);
	}

	private void init(PluginContext context, XLog log) {
		this.setLayout(new GridLayout(1,2));
		PPMChartAnalysis ppmca = new PPMChartAnalysis(context,new PPMChartModel(context, log));
		ppmcop = new PPMChartOptionPanel(ppmca);
		this.add(ppmcop.getOptionPanel(false));
		fp = new FilterPanel(ppmca.getPPMChartPanel(), log);
		this.add(fp);
		cp = ppmca.getSettingPanel().getChunkPanel();
		this.add(cp);

		this.validate();
		this.repaint();
	}

	public String getColorStandard() { return ppmcop.getColorStandard(); }
	public String getShapeStandard() { return ppmcop.getShapeStandard(); }
	public String getSortStandard() { return ppmcop.getSortStandard(); }
	public String getComponentType() { return ppmcop.getComponentType(); }
	public String getTotalWidth() { return ppmcop.getTotalWidth(); }
	public long getWidthDivider() { return ppmcop.getWidthDivider(); }
	public JSlider getZoomSliderX() { return ppmcop.getZoomSliderX(); }
	public JSlider getZoomSliderY() { return ppmcop.getZoomSliderY(); }
	public String getTimeOption() { return ppmcop.getTimeOption(); }
	public boolean isDescCheckBoxSelected() { return ppmcop.isDescCheckBoxSelected(); }
	
	public boolean isCreaSelected() { return fp.isCreaSelected(); }
	public boolean isMoveSelected() { return fp.isMoveSelected(); }
	public boolean isDeleSelected() { return fp.isDeleSelected(); }
	public boolean isNameSelected() { return fp.isNameSelected(); }

	public boolean isActSelected() { return fp.isActSelected(); }
	public boolean isStaSelected() { return fp.isStaSelected(); }
	public boolean isEndSelected() { return fp.isEndSelected(); }
	public boolean isAndSelected() { return fp.isAndSelected(); }
	public boolean isXorSelected() { return fp.isXorSelected(); }
	public boolean isEdgSelected() { return fp.isEdgSelected(); }

	public boolean isAllItemsSelected() { return fp.isAllItemsSelected(); }
	
	public int getLocalityChunks() { return cp.getLocalityChunks(); }
	public int getSimilarityChunks() { return cp.getSimilarityChunks(); }
	public int getTimingChunks() { return cp.getTimingChunks(); }
}
