package org.processmining.plugins.ppm.ppmchart;

import org.deckfour.xes.extension.std.XConceptExtension;
import org.deckfour.xes.model.XLog;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.plugins.ppm.ppmchart.model.PPMChartModel;

@Plugin(name = "PPMChart Analysis", 
        parameterLabels = { "log" }, 
        returnLabels = { "PPMChart Analysis" }, 
        returnTypes = { PPMChartModel.class }, 
        userAccessible = true, 
        help = "Analyze the process of process modeling using PPMChart")
public class PPMChartAnalysisPlugin {
			        

	@UITopiaVariant(uiLabel = "PPMChart Analysis", 
			        affiliation = "Ghent University",
			        author = "J. Claes", 
			        email = "jan.claes@ugent.be",
			        website = "http://www.janclaes.info")
	@PluginVariant(variantLabel = "PPMChart Analysis", requiredParameterLabels = { 0 })
	public static PPMChartModel makeChart(PluginContext context, XLog log) {
		java.util.Date now = new java.util.Date();
		System.out.println(now.getHours() + ":" + now.getMinutes() + ";" + XConceptExtension.instance().extractName(log));
		return new PPMChartModel(context, log);
	}
	
	@UITopiaVariant(uiLabel = "PPMChart Analysis", 
	        affiliation = "Ghent University",
	        author = "J. Claes", 
	        email = "jan.claes@ugent.be",
	        website = "http://www.janclaes.info")
	@PluginVariant(variantLabel = "PPMChart Analysis", requiredParameterLabels = { 0 })
	public static PPMChartModel makeChart(UIPluginContext context, XLog log) {
		java.util.Date now = new java.util.Date();
		System.out.println(now.getHours() + ":" + now.getMinutes() + ";" + XConceptExtension.instance().extractName(log));
		return new PPMChartModel(context, log);
	}
}
