package org.processmining.plugins.ppm.ppmchart.model;

public class Node {
	private String id;
	private boolean deleted;
	private long x, y;
	private double distance;
	public enum TYPE { UNKNOWN, ACTIVITY, START_EVENT, END_EVENT, XOR, AND };
	private TYPE type;
	
	public Node(String id, long x, long y) {
		this(id, TYPE.UNKNOWN, x, y);
	}
	public Node(String id, TYPE type, long x, long y) {
		this.id = id;
		this.type = type;
		this.x = x;
		this.y = y;
		deleted = false;
		distance = -1;
	}
	
	public String getId() {
		return id;
	}
	public TYPE getType() {
		return type;
	}
	public boolean isDeleted() {
		return deleted;
	}
	public long getX() {
		return x;
	}
	public long getY() {
		return y;
	}
	public double getDistance() {
		return distance;
	}
	
	public Node setType(TYPE type) {
		this.type = type;
		return this;
	}
	public Node setDeleted(boolean b) {
		deleted = b;
		return this;
	}
	public Node setX(long x) {
		this.x = x;
		return this;
	}
	public Node setY(long y) {
		this.y = y;
		return this;
	}
	public Node setDistance (double d) {
		distance = d;
		return this;
	}
}
