package org.processmining.plugins.ppm.ppmchart.ui;

import java.awt.Color;
import java.util.HashMap;
import java.util.Random;

public class ColorReference {

	protected HashMap<String, Color> mappings = null;
	protected Color[] colors = null;
	protected boolean[] assigned = null;
	protected Random rnd = null;

	public ColorReference() {
		mappings = new HashMap<String, Color>();
		rnd = new Random();
		// standard colors
		Color green = new Color(0, 255, 0);
		Color darkGreen = new Color(0, 153, 0);
		Color lightGreen = new Color(159, 255, 159);
		Color extraLightGreen  = new Color(209, 255, 209);
		Color red = new Color(255, 0, 0);
		Color darkRed = new Color(222, 0, 0);
		Color lightRed = new Color(255, 93, 93);
		Color extraLightRed = new Color(255, 189, 189);
		Color blue = new Color(0, 0, 255);
		Color darkBlue = new Color(0, 0, 153);
		Color lightBlue= new Color(155, 155, 255);
		Color extraLightBlue = new Color(221, 221, 255);
		Color orange = new Color(255, 192, 0);
		Color grey = new Color(153, 153, 153);
		Color  lightpink = new Color(255, 217, 217);;
		mappings.put(EventReference.CREATE_ACTIVITY, green);
		mappings.put(EventReference.CREATE_AND, darkGreen);
		mappings.put(EventReference.CREATE_EDGE, lightGreen);
		mappings.put(EventReference.CREATE_EDGE_BENDPOINT, grey);
		mappings.put(EventReference.CREATE_END_EVENT, extraLightGreen);
		mappings.put(EventReference.CREATE_START_EVENT, extraLightGreen);
		mappings.put(EventReference.CREATE_XOR, darkGreen);
		mappings.put(EventReference.DELETE_ACTIVITY, red);
		mappings.put(EventReference.DELETE_AND, darkRed);
		mappings.put(EventReference.DELETE_EDGE, lightRed);
		mappings.put(EventReference.DELETE_EDGE_BENDPOINT, grey);
		mappings.put(EventReference.DELETE_END_EVENT, extraLightRed);
		mappings.put(EventReference.DELETE_START_EVENT, extraLightRed);
		mappings.put(EventReference.DELETE_XOR, darkRed);
		mappings.put(EventReference.MOVE_ACTIVITY, blue);
		mappings.put(EventReference.MOVE_AND, darkBlue);
		mappings.put(EventReference.MOVE_EDGE_BENDPOINT, grey);
		mappings.put(EventReference.MOVE_EDGE_LABEL, grey);
		mappings.put(EventReference.MOVE_END_EVENT, extraLightBlue);
		mappings.put(EventReference.MOVE_START_EVENT, extraLightBlue);
		mappings.put(EventReference.MOVE_XOR, darkBlue);
		mappings.put(EventReference.RECONNECT_EDGE, lightBlue);
		mappings.put(EventReference.NAME_ACTIVITY, orange);
		mappings.put(EventReference.NAME_EDGE, orange);
		mappings.put(EventReference.RENAME_ACTIVITY, orange);
		mappings.put(EventReference.RENAME_EDGE, orange);
		// assignment map
		assigned = new boolean[16];
		for (int i = 0; i < assigned.length; i++) {
			assigned[i] = true;
		}
	}

	public Color getColor(String key) {
		if (mappings.containsKey(key)) {
			// return previously mapped color
			return mappings.get(key);
		} else {
			// check for available standard color
			for (int i = 0; i < assigned.length; i++) {
				if (assigned[i] == false) {
					assigned[i] = true;
					mappings.put(key, colors[i]);
					return colors[i];
				}
			}
			// create random color
			Color random = new Color(rnd.nextInt(245), rnd.nextInt(245), rnd.nextInt(245));
			mappings.put(key, random);
			return random;
		}
	}

	public void freeColor(String key) {
		Color c = mappings.remove(key);
		for (int i = 0; i < colors.length; i++) {
			if (colors[i].equals(c)) {
				assigned[i] = false;
				return;
			}
		}
	}

	public void assignColor(String key, Color color) {
		mappings.put(key, color);
	}

	public void randomizeColor(String key) {
		Color random = new Color(rnd.nextInt(245), rnd.nextInt(245), rnd.nextInt(245));
		mappings.put(key, random);
	}
}
