package org.processmining.plugins.ppm.ppmchart.ui;

import org.processmining.plugins.ppm.ppmchart.model.PPMChartModel;

public class CoordinationUtil {

	private int clipL = 0;
	private int clipR = PPMChartPanel.SCREENLENGTH;
	protected PPMChartOptionPanel ccop = null;
	protected PPMChartModel ccModel = null;

	private int clipU = 0;
	private int clipB = PPMChartPanel.SCREENLENGTH;

	public void setClipL(int clipL) {
		this.clipL = clipL;
	}

	public void setClipR(int clipR) {
		this.clipR = clipR;
	}

	public int getClipL() {
		return clipL;
	}

	public int getClipR() {
		return clipR;
	}

	public void setClipU(int clipU) {
		this.clipU = clipU;
	}

	public void setClipB(int clipB) {
		this.clipB = clipB;
	}

	public int getClipU() {
		return clipU;
	}

	public int getClipB() {
		return clipB;
	}

	public CoordinationUtil(PPMChartOptionPanel ccop, PPMChartModel ccModel) {
		this.ccop = ccop;
		this.ccModel = ccModel;
	}

	protected double milli2pixels = 1.0; // the ratio between milliseconds and displayed pixels
	protected double height2pixels = 1.0; // the ratio between heights and displayed pixels
	protected static int border = 5;

	public double getMilli2pixels() {
		return milli2pixels;
	}

	public void updateMilli2pixelsRatio(int width, int border) {
		String str = ccop.getTimeOption();
		if (str.equals(PPMChartModel.TIME_ACTUAL)) {
			milli2pixels = (double) (width - border * 2)
					/ (double) (ccModel.getLogMaxValueforScreen() - ccModel.getLogMinValueforScreen()); // + 2 is added to extend bound
		} else if (str.equals(PPMChartModel.TIME_RELATIVE_TIME)) {
			milli2pixels = (double) (width - border * 2) / (double) (ccModel.getLogRelativeMaxValue() - 0); // + 2 is added to extend bound
		} else if (str.equals(PPMChartModel.TIME_RELATIVE_RATIO)) {
			milli2pixels = (double) (width - border * 2) / (double) (ccModel.getLogRelativeRatioMaxValue() - 0); // + 2 is added to extend bound
//		} else if (str.equals(PPMChartModel.TIME_LOGICAL_RELATIVE)) {
//			milli2pixels = (double) (width - border * 2) / (double) (ccModel.getLogLogiclRelativeMaxValue() - 0); // + 2 is added to extend bound
		}
		if ((milli2pixels == 1) || (milli2pixels == 0)) {
			return;
		}
	}

	public double updateMilli2pixelsRatioBuffer(int width, int border) {
		String str = ccop.getTimeOption();
		double milli2pixels = 0;
		if (str.equals(PPMChartModel.TIME_ACTUAL)) {
			milli2pixels = (double) (width - border * 2)
					/ (double) (ccModel.getLogMaxValueforScreen() - ccModel.getLogMinValueforScreen()); // + 2 is added to extend bound
		} else if (str.equals(PPMChartModel.TIME_RELATIVE_TIME)) {
			milli2pixels = (double) (width - border * 2) / (double) (ccModel.getLogRelativeMaxValue() - 0); // + 2 is added to extend bound
		} else if (str.equals(PPMChartModel.TIME_RELATIVE_RATIO)) {
			milli2pixels = (double) (width - border * 2) / (double) (ccModel.getLogRelativeRatioMaxValue() - 0); // + 2 is added to extend bound
//		} else if (str.equals(PPMChartModel.TIME_LOGICAL_RELATIVE)) {
//			milli2pixels = (double) (width - border * 2) / (double) (ccModel.getLogLogiclRelativeMaxValue() - 0); // + 2 is added to extend bound
		}
		return milli2pixels;
	}

	public int unit2CordHeight(int unit_number, int size, int height, int border) {
		return (int) (border + ((double) (height - 2 * border) / size * unit_number));
	}

	public int unit2CordOverview(int unit_number, int height, int size) {
		return (int) (((double) (height) / size * unit_number));
	}

	public int time2coord(long aTimeMillis) {
		String str = ccop.getTimeOption();
		if (str.equals(PPMChartModel.TIME_ACTUAL)) {
			return (int) ((aTimeMillis - ccModel.getLogMinValueforScreen()) * getMilli2pixels());
		} else {
			return (int) ((aTimeMillis) * getMilli2pixels());
		}
	}

	public int time2coordOverview(long aTimeMillis, double milli2pixels) {
		String str = ccop.getTimeOption();
		if (str.equals(PPMChartModel.TIME_ACTUAL)) {
			return (int) ((aTimeMillis - ccModel.getLogMinValueforScreen()) * milli2pixels);
		} else {
			return (int) ((aTimeMillis) * milli2pixels);
		}
	}

	public long coord2timeMillis(double anX) {
		if (ccop.getTimeOption().equals(PPMChartModel.TIME_ACTUAL)) {
			return (long) (anX / getMilli2pixels()) + ccModel.getLogMinValueforScreen();
		} else {
			return (long) (anX / getMilli2pixels());
		}
	}

	// convenient methods for unit height
	public int getUnitHeight(int imageHeight, int border) {
		int height = imageHeight - (2 * border);
		return (height / ccModel.getComponentSize(ccop.getComponentType()));
	}
}
