package org.processmining.plugins.ppm.ppmchart.ui;

import java.awt.*;
import java.awt.event.*;

import javax.swing.JPanel;

import org.processmining.plugins.ppm.ppmchart.PPMChartAnalysis;

public class OverviewPanel extends JPanel implements MouseMotionListener, MouseListener {

	private static final long serialVersionUID = -2720292789575028503L;

	private PPMChartAnalysis cca = null; // parents
	private boolean drawImage = true;
	private int x1, y1, width, height;
	private int p_x, p_y;
	private int x1_o, y1_o;
	private boolean clicked = false;

	public OverviewPanel(PPMChartAnalysis aCCA) {
		cca = aCCA;
		addMouseListener(this);
		addMouseMotionListener(this);
	}

	public void setDrawBox(boolean b) {
		drawImage = b;
	}

	public void paintComponent(Graphics grx) {
		if (drawImage) {
			cca.getPPMChartPanel().generateBufferedImage(grx, 200, 130);
			drawImage = false;
		}
		grx.drawImage(cca.getPPMChartPanel().getBufferedImage(), 0, 0, this);
		drawBox(grx);
	}

	public void drawBox(Graphics grx) {
		double width_o, height_o, width_v, height_v;
		Point p;

		width_o = cca.getPPMChartPanel().getWidth();
		height_o = cca.getPPMChartPanel().getHeight();
		width_v = cca.getScrollPane().getViewport().getWidth();
		height_v = cca.getScrollPane().getViewport().getHeight();
		p = cca.getScrollPane().getViewport().getViewPosition();

		x1 = (int) ((200.0 / width_o) * p.x);
		y1 = (int) ((130.0 / height_o) * p.y);
		width = (int) (199.0 * (width_v / width_o));
		height = (int) (129.0 * (height_v / height_o));
		if (width < 5) {
			width = 5;
		}
		if (height < 5) {
			height = 5;
		}
		grx.setColor(Color.red);
		grx.drawRect(x1, y1, width, height);
	}

	////// mouse events
	public void mouseMoved(MouseEvent e) {

	}

	public void mouseDragged(MouseEvent e) {
		Point p = e.getPoint();

		if (clicked) {
			double width_o = cca.getPPMChartPanel().getWidth();
			double height_o = cca.getPPMChartPanel().getHeight();
			int x2 = x1_o + p.x - p_x;
			int y2 = y1_o + p.y - p_y;
			int x3 = (int) (x2 * (width_o / 200));
			int y3 = (int) (y2 * (height_o / 130));
			cca.setScrollBarPosition(new Point(x3, y3));
		}
		this.repaint();
		revalidate();
	}

	///MOUSE Listener ///////////////////////////////////////////
	public void mousePressed(MouseEvent e) {
		Point p = e.getPoint();
		if ((p.x >= x1) && (p.x <= x1 + width) && (p.y > y1) && (p.y <= y1 + height)) {
			clicked = true;
			x1_o = x1;
			y1_o = y1;
			p_x = p.x;
			p_y = p.y;
		}
	}

	public void mouseReleased(MouseEvent e) {
		clicked = false;
	}

	public void mouseEntered(MouseEvent e) {
	}

	public void mouseExited(MouseEvent e) {
	}

	public void mouseClicked(MouseEvent e) {

	}

}
