package org.processmining.plugins.ppm.ppmchart.ui;

import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.util.ArrayList;
import java.util.Hashtable;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.SwingConstants;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import org.processmining.plugins.ppm.ppmchart.PPMChartAnalysis;
import org.processmining.plugins.ppm.ppmchart.model.PPMChartModel;

public class PPMChartOptionPanel implements ChangeListener, ActionListener, ItemListener {

	public static Color ColorBg = new Color(120, 120, 120);
	public static Color ColorInnerBg = new Color(140, 140, 140);
	public static Color ColorFg = new Color(30, 30, 30);
	public static Color ColorTextAreaBg = new Color(160, 160, 160);

	protected PPMChartPanel ccPanel = null;
	private PPMChartAnalysis ccAnalysis = null;

	///////////// to do 
	protected ArrayList<String> eventTypeToKeep;
	// label
	private final JLabel optionLabel = new JLabel("Options");
	private final JLabel componentLabel = new JLabel("Component type:");
	private final JLabel colorByLabel = new JLabel("Color By:");
	private final JLabel shapeByLabel = new JLabel("Shape By:");
	private final JLabel sortByLabel = new JLabel("Sort By:");
	private final JLabel mouseModeLabel = new JLabel("Mouse Mode:");
	private final JLabel timeOptionLabel = new JLabel("Time option:");
	private final JLabel widthLabel = new JLabel("Total width:");
	private final String[] widths = { "10 min", "20 min", "30 min", "1 hour", "1,5 hours", "2 hours" };
	private final JComboBox widthBox = new JComboBox(widths);
	private final String[] widthSorts = { "L-1", "L-10", "L-100", "L-500", "seconds", "minutes", "half hours", "hours", // width option
			"days", "weeks", "months", "years" };
	private final long[] widthDividers = { 1, 10, 100, 500, 1000, 60000, 1800000L, 3600000L, 86400000L, 604800000L, 2592000000L,
			31536000000L };
	private final JComboBox widthSortBox = new JComboBox(widthSorts);
	private final JLabel widthSortLabel = new JLabel("Time intervals:");
	private final String[] timeOptions = { PPMChartModel.TIME_ACTUAL, PPMChartModel.TIME_RELATIVE_TIME,
			PPMChartModel.TIME_RELATIVE_RATIO, //PPMChartPanel.TIME_LOGICAL,
			/*PPMChartModel.TIME_LOGICAL_RELATIVE,*/ }; // array of "time option" strings required to fill the timeOptionBox combobox with
	private final JComboBox timeOptionBox = new JComboBox(timeOptions);
	private final JComboBox componentBox = new JComboBox();
	private final JComboBox colorByBox = new JComboBox();
	private final JComboBox shapeByBox = new JComboBox();
	private final JComboBox sortByBox = new JComboBox();
	private final JCheckBox descCheckBox = new JCheckBox("descending");
	private final JCheckBox sizeCheckBox = new JCheckBox("Size shows # of events", true);
	private final JButton jbuttonZoom = new JButton("Zoom out");
	private final JButton jbuttonAction = new JButton("Update");
	private final JComboBox mouseMode = new JComboBox();
	protected JSlider zoomSliderX = null; // slider for zooming the view
	protected JSlider zoomSliderY = null; // slider for zooming the view
	protected String currentTimeOption = PPMChartModel.TIME_ACTUAL;

	public PPMChartOptionPanel(PPMChartAnalysis aCCA) {
		ccAnalysis = aCCA;
		initializeComponentBox();
		widthBox.setSelectedItem("1 hour");
		widthSortBox.setSelectedItem("hours");
		sizeCheckBox.setSelected(false);
	}

	public JPanel getOptionPanel(boolean includeInteractiveItems) {
		JPanel panel = new JPanel();
		panel.setBackground(ColorBg);
		//initialize westpanel
		panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));
		panel.setAlignmentX(Component.LEFT_ALIGNMENT);
		panel.setPreferredSize(new Dimension(170, 400));
		panel.add(Box.createRigidArea(new Dimension(5, 2)));
		optionLabel.setAlignmentX(Component.LEFT_ALIGNMENT);
		optionLabel.setFont(new Font("SansSerif", Font.BOLD, 16));
		panel.add(optionLabel);
		// add component option
		panel.add(Box.createRigidArea(new Dimension(5, 2)));
		componentLabel.setAlignmentX(Component.LEFT_ALIGNMENT);
		panel.add(componentLabel);
		componentBox.setMaximumSize(new Dimension(160, 20));
		componentBox.setAlignmentX(Component.LEFT_ALIGNMENT);
		panel.add(Box.createRigidArea(new Dimension(5, 0)));
		panel.add(componentBox);
		// add time option
		panel.add(Box.createRigidArea(new Dimension(5, 2)));
		panel.add(timeOptionLabel);
		timeOptionBox.setMaximumSize(new Dimension(160, 20));
		timeOptionBox.setAlignmentX(Component.LEFT_ALIGNMENT);
		panel.add(Box.createRigidArea(new Dimension(5, 0)));
		panel.add(timeOptionBox);
		// add width sort option
		panel.add(Box.createRigidArea(new Dimension(5, 2)));
		panel.add(widthSortLabel);
		widthSortBox.setMaximumSize(new Dimension(160, 20));
		widthSortBox.setAlignmentX(Component.LEFT_ALIGNMENT);
		panel.add(Box.createRigidArea(new Dimension(5, 0)));
		panel.add(widthSortBox);
		//widthSortBox.setEnabled(false);
		// add colorBy option
		panel.add(Box.createRigidArea(new Dimension(5, 2)));
		colorByLabel.setAlignmentX(Component.LEFT_ALIGNMENT);
		panel.add(colorByLabel);
		colorByBox.setMaximumSize(new Dimension(160, 20));
		colorByBox.setAlignmentX(Component.LEFT_ALIGNMENT);
		panel.add(Box.createRigidArea(new Dimension(5, 0)));
		panel.add(colorByBox);
		// size check box
		//panel.add(sizeCheckBox);
		// add shapeBy option
		panel.add(Box.createRigidArea(new Dimension(5, 2)));
		shapeByLabel.setAlignmentX(Component.LEFT_ALIGNMENT);
		panel.add(shapeByLabel);
		shapeByBox.setMaximumSize(new Dimension(160, 20));
		shapeByBox.setAlignmentX(Component.LEFT_ALIGNMENT);
		panel.add(Box.createRigidArea(new Dimension(5, 0)));
		panel.add(shapeByBox);
		// add sortBy option
		panel.add(Box.createRigidArea(new Dimension(5, 2)));
		sortByLabel.setAlignmentX(Component.LEFT_ALIGNMENT);
		panel.add(sortByLabel);
		sortByBox.setMaximumSize(new Dimension(160, 20));
		sortByBox.setAlignmentX(Component.LEFT_ALIGNMENT);
		panel.add(Box.createRigidArea(new Dimension(5, 0)));
		panel.add(sortByBox);
		panel.add(descCheckBox);
		if (includeInteractiveItems)
		{
			// add mouseMode option
			//		panel.add(Box.createRigidArea(new Dimension(5, 2)));
			mouseModeLabel.setAlignmentX(Component.LEFT_ALIGNMENT);
			panel.add(mouseModeLabel);
			mouseMode.setMaximumSize(new Dimension(160, 20));
			mouseMode.setAlignmentX(Component.LEFT_ALIGNMENT);
			panel.add(Box.createRigidArea(new Dimension(5, 0)));
			panel.add(mouseMode);
		}
		//		// add "show line box"
		//		panel.add(Box.createRigidArea(new Dimension(5, 10)));
		//		checkLineBox.setAlignmentX(LEFT_ALIGNMENT);
		//		checkLineBox.setSelected(false);
		//		panel.add(checkLineBox);
		if (!includeInteractiveItems)
		{
			// add width  option
			panel.add(Box.createRigidArea(new Dimension(5, 2)));
			panel.add(widthLabel);
			widthBox.setMaximumSize(new Dimension(160, 20));
			widthBox.setAlignmentX(Component.LEFT_ALIGNMENT);
			panel.add(Box.createRigidArea(new Dimension(5, 0)));
			panel.add(widthBox);
		}
		zoomSliderX = new JSlider(SwingConstants.VERTICAL, 0, 3000, 0); // zooms in view
		zoomSliderY = new JSlider(SwingConstants.VERTICAL, 0, 3000, 0); // zooms in view
		if (includeInteractiveItems)
		{
			// add zoom slide bar for X
			setZoomSliderXValue(1);
			zoomSliderX.setMaximumSize(new Dimension(80, 120));
			Hashtable<Integer, JLabel> zoomLabelTableX = new Hashtable<Integer, JLabel>();
			zoomLabelTableX.put(new Integer(0), new JLabel("1x"));
			zoomLabelTableX.put(new Integer(1000), new JLabel("10x"));
			zoomLabelTableX.put(new Integer(2000), new JLabel("(10^2)x"));
			zoomLabelTableX.put(new Integer(3000), new JLabel("(10^3)x"));
			zoomSliderX.setLabelTable(zoomLabelTableX);
			zoomSliderX.setMajorTickSpacing(1000);
			zoomSliderX.setMinorTickSpacing(500);
			zoomSliderX.setPaintTicks(true);
			zoomSliderX.setPaintLabels(true);
			zoomSliderX.addChangeListener(this);
			zoomSliderX.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));
			JLabel zoomLabelX = new JLabel("zoom (X)");
			zoomLabelX.setAlignmentX(Component.CENTER_ALIGNMENT);
			zoomLabelX.setBorder(BorderFactory.createEmptyBorder(2, 2, 2, 2));
			JPanel zoomPanelX = new JPanel();
			zoomPanelX.setLayout(new BoxLayout(zoomPanelX, BoxLayout.Y_AXIS));
			zoomPanelX.setBorder(BorderFactory.createLoweredBevelBorder());
			zoomPanelX.setMinimumSize(new Dimension(80, 120));
			zoomPanelX.add(zoomSliderX);
			zoomPanelX.add(zoomLabelX);
			// add zoom slide bar for Y
			zoomSliderY.setMaximumSize(new Dimension(80, 120));
			Hashtable<Integer, JLabel> zoomLabelTableY = new Hashtable<Integer, JLabel>();
			zoomLabelTableY.put(new Integer(0), new JLabel("1x"));
			zoomLabelTableY.put(new Integer(1000), new JLabel("10x"));
			zoomLabelTableY.put(new Integer(2000), new JLabel("(10^2)x"));
			zoomLabelTableY.put(new Integer(3000), new JLabel("(10^3)x"));
			zoomSliderY.setLabelTable(zoomLabelTableY);
			zoomSliderY.setMajorTickSpacing(1000);
			zoomSliderY.setMinorTickSpacing(500);
			zoomSliderY.setPaintTicks(true);
			zoomSliderY.setPaintLabels(true);
			zoomSliderY.addChangeListener(this);
			zoomSliderY.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));
			JLabel zoomLabelY = new JLabel("zoom (Y)");
			zoomLabelY.setAlignmentX(Component.CENTER_ALIGNMENT);
			zoomLabelY.setBorder(BorderFactory.createEmptyBorder(2, 2, 2, 2));
			JPanel zoomPanelY = new JPanel();
			zoomPanelY.setLayout(new BoxLayout(zoomPanelY, BoxLayout.Y_AXIS));
			zoomPanelY.setBorder(BorderFactory.createLoweredBevelBorder());
			zoomPanelY.setMinimumSize(new Dimension(80, 120));
			zoomPanelY.add(zoomSliderY);
			zoomPanelY.add(zoomLabelY);
	
			JPanel zoomPanel = new JPanel();
			zoomPanel.setLayout(new BoxLayout(zoomPanel, BoxLayout.X_AXIS));
			zoomPanel.setMaximumSize(new Dimension(160, 120));
			zoomPanel.setPreferredSize(new Dimension(160, 120));
			zoomPanel.add(zoomPanelX);
			zoomPanel.add(zoomPanelY);
	
			panel.add(Box.createRigidArea(new Dimension(5, 15)));
			zoomPanel.setAlignmentX(Component.LEFT_ALIGNMENT);
			panel.add(zoomPanel);

			// add "zoom out button"
			panel.add(jbuttonZoom);
			// add "action button"
			panel.add(jbuttonAction);
			panel.add(Box.createRigidArea(new Dimension(5, 10)));
		}
		
		return panel;
	}

	public String getColorStandard() {
		return (String) colorByBox.getSelectedItem();
	}
	public void setColorStandard(String s) {
		colorByBox.setSelectedItem(s);
	}

	public String getShapeStandard() {
		String selItem = (String) shapeByBox.getSelectedItem();
		if (selItem.equals(PPMChartModel.ST_INST))
			return PPMChartModel.ST_TASK;
		else
			return selItem;
	}
	public void setShapeStandard(String s) {
		if (s.equals(PPMChartModel.ST_TASK))
			shapeByBox.setSelectedItem(PPMChartModel.ST_INST);
		else
			shapeByBox.setSelectedItem(s);
	}

	public String getSortStandard() {
		return (String) sortByBox.getSelectedItem();
	}
	public void setSortStandard(String s) {
		sortByBox.setSelectedItem(s);
	}

	public String getMouseMode() {
		return (String) mouseMode.getSelectedItem();
	}
	public void setMouseMode(String s) {
		mouseMode.setSelectedItem(s);
	}

	public String getComponentType() {
		return (String) componentBox.getSelectedItem();
	}
	public void setComponentType(String s) {
		componentBox.setSelectedItem(s);
	}

	public String getTotalWidth() {
		return (String) widthBox.getSelectedItem();
	}
	public void setTotalWidth(String s) {
		widthBox.setSelectedItem(s);
	}

	public long getWidthDivider() {
		return widthDividers[widthSortBox.getSelectedIndex()];
	}
	public void setWidthDivider(long l) {
		for (int i=0; i<widthDividers.length; i++)
			if (widthDividers[i] == l)
				widthSortBox.setSelectedIndex(i);
	}

	public JSlider getZoomSliderX() {
		return zoomSliderX;
	}
	public void setZoomSliderX(JSlider s) {
		zoomSliderX = s;
		stateChanged(new ChangeEvent(zoomSliderX));
	}

	public JSlider getZoomSliderY() {
		return zoomSliderY;
	}
	public void setZoomSliderY(JSlider s) {
		zoomSliderY = s;
		stateChanged(new ChangeEvent(zoomSliderY));
	}

	public String getTimeOption() {
		return (String) timeOptionBox.getSelectedItem();
	}
	public void setTimeOption(String s) {
		timeOptionBox.setSelectedItem(s);
	}

	public void changeWidthSort(int idx) {
		widthSortBox.setSelectedIndex(idx);
	}

	public boolean isDescCheckBoxSelected() {
		return descCheckBox.isSelected();
	}
	public void setDescCheckBoxSelected(boolean b) {
		descCheckBox.setSelected(b);
	}

	public boolean isSizeCheckBoxSelected() {
		return sizeCheckBox.isSelected();
	}
	public void setSizeCheckBoxSelected(boolean b) {
		sizeCheckBox.setSelected(b);
	}

	private void initializeComponentBox() {
		componentBox.addItem(PPMChartModel.ST_INST);
		componentBox.setSelectedItem(PPMChartModel.ST_INST);
		
		colorByBox.addItem(PPMChartModel.ST_NONE);
		colorByBox.addItem(PPMChartModel.ST_TASK);
		colorByBox.setSelectedItem(PPMChartModel.ST_TASK);
		
		shapeByBox.addItem(PPMChartModel.ST_NONE);
		shapeByBox.addItem(PPMChartModel.ST_INST);
		shapeByBox.setSelectedItem(PPMChartModel.ST_INST);
		
		sortByBox.addItem(PPMChartModel.ST_NONE);
		sortByBox.addItem(PPMChartPanel.ST_NAME);
		sortByBox.addItem(PPMChartPanel.ST_SIZE);
		sortByBox.addItem(PPMChartPanel.ST_SPAN);
		sortByBox.addItem(PPMChartPanel.ST_DIST_START);
		sortByBox.addItem(PPMChartPanel.ST_CREATE_ORDER);
		sortByBox.addItem(PPMChartPanel.ST_FIRST_EVENT);
		sortByBox.addItem(PPMChartPanel.ST_LAST_EVENT);
		sortByBox.setSelectedItem(PPMChartPanel.ST_DIST_START);

		mouseMode.addItem(PPMChartPanel.ST_SELECT);
		mouseMode.addItem(PPMChartPanel.ST_ZOOMIN);
		mouseMode.addItem(PPMChartPanel.ST_DRAG);
	}

	public void registerGUIListener(PPMChartPanel aCCPanel) {
		ccPanel = aCCPanel;
		jbuttonAction.addActionListener(this);
		jbuttonZoom.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				changeSlider();
				ccPanel.initBufferedImage();

				ccPanel.repaint();
			}
		});
		//		colorByBox.addActionListener(this);
		//		shapeByBox.addActionListener(this);
		sizeCheckBox.addItemListener(this);
	}

	public void zoomOut() {
		changeSlider();
		ccPanel.initBufferedImage();
		ccPanel.repaint();
	}

	public void changeSlider() {
		zoomSliderX.setValue(0);
		zoomSliderX.repaint();
		zoomSliderY.setValue(0);
		zoomSliderY.repaint();
	}


	public void setZoomSliderXValue(double zoomLevel) {
		double slider = StrictMath.log10(zoomLevel) * 1000.0;
		zoomSliderX.setValue((int)Math.round(slider));
		ccPanel.setViewportZoomX(1.0 / zoomLevel);
		ccPanel.adjustWidth();
		ccPanel.revalidate();
		ccAnalysis.reDrawBoxOnOverview();
	}
	public void stateChanged(ChangeEvent e) {
		// handle zoom events
		if ((e.getSource() == zoomSliderX)) {
			if (!zoomSliderX.getValueIsAdjusting()) {
				double zoom = StrictMath.pow(10.0, (zoomSliderX.getValue() / 1000.0));
				ccPanel.setViewportZoomX(1.0 / zoom);
				ccPanel.adjustWidth();
				ccPanel.revalidate();
				ccAnalysis.reDrawBoxOnOverview();
			}
		} else if ((e.getSource() == zoomSliderY)) {
			if (!zoomSliderY.getValueIsAdjusting()) {
				double zoom = StrictMath.pow(10.0, (zoomSliderY.getValue() / 1000.0));
				ccPanel.setViewportZoomY(1.0 / zoom);
				ccPanel.revalidate();
				ccAnalysis.reDrawBoxOnOverview();
			}
		}
	}

	public void itemStateChanged(ItemEvent e) {
		Object source = e.getItemSelectable();
		//		if (source == descCheckBox) {
		//			dcPanel.repaint();
		//		}
		/*if (source == sizeCheckBox) {
			if (sizeCheckBox.isSelected()) {
				shapeByBox.setEnabled(false);
			} else {
				shapeByBox.setEnabled(true);
			}
		}*/
	}

	public void actionPerformed(ActionEvent e) {
		ccPanel.changeDots();
		ccPanel.initBufferedImage();
		ccPanel.revalidate();
		ccPanel.repaint();
		ccAnalysis.actionPerformed(e);
	}

}
