package org.processmining.plugins.ppm.ppmchart.ui;

import java.util.HashMap;

public class ShapeReference {
	public static String DOT = "Dot";
	public static String CIRCLE = "Circle";
	public static String TRIANGLE = "Triangle";
	public static String BOX = "Box";
	public static String RHOMBUS = "Rhombus";
	public static String[] shapeList = new String[] { DOT, CIRCLE, TRIANGLE, BOX, RHOMBUS };
	public static int index = 0;
	
	protected HashMap<String, String> mappings = null;
	protected boolean[] assigned = null;

	public ShapeReference() {
		mappings = new HashMap<String, String>();
		mappings.put(EventReference.CREATE_ACTIVITY, BOX);
		mappings.put(EventReference.CREATE_AND, RHOMBUS);
		mappings.put(EventReference.CREATE_EDGE, TRIANGLE);
		mappings.put(EventReference.CREATE_EDGE_BENDPOINT, TRIANGLE);
		mappings.put(EventReference.CREATE_END_EVENT, CIRCLE);
		mappings.put(EventReference.CREATE_START_EVENT, CIRCLE);
		mappings.put(EventReference.CREATE_XOR, RHOMBUS);
		mappings.put(EventReference.DELETE_ACTIVITY, BOX);
		mappings.put(EventReference.DELETE_AND, RHOMBUS);
		mappings.put(EventReference.DELETE_EDGE, TRIANGLE);
		mappings.put(EventReference.DELETE_EDGE_BENDPOINT, TRIANGLE);
		mappings.put(EventReference.DELETE_END_EVENT, CIRCLE);
		mappings.put(EventReference.DELETE_START_EVENT, CIRCLE);
		mappings.put(EventReference.DELETE_XOR, RHOMBUS);
		mappings.put(EventReference.MOVE_ACTIVITY, BOX);
		mappings.put(EventReference.MOVE_AND, RHOMBUS);
		mappings.put(EventReference.MOVE_EDGE_BENDPOINT, TRIANGLE);
		mappings.put(EventReference.MOVE_EDGE_LABEL, TRIANGLE);
		mappings.put(EventReference.MOVE_END_EVENT, CIRCLE);
		mappings.put(EventReference.MOVE_START_EVENT, CIRCLE);
		mappings.put(EventReference.MOVE_XOR, RHOMBUS);
		mappings.put(EventReference.RECONNECT_EDGE, TRIANGLE);
		mappings.put(EventReference.NAME_ACTIVITY, BOX);
		mappings.put(EventReference.NAME_EDGE, TRIANGLE);
		mappings.put(EventReference.RENAME_ACTIVITY, BOX);
		mappings.put(EventReference.RENAME_EDGE, TRIANGLE);
	}

	public String getShape(String key) {
		if (mappings.containsKey(key)) {
			// return previously mapped color
			return mappings.get(key);
		} else {
			// assign shape
			String str = shapeList[index % 8];
			index++;
			mappings.put(key, str);
			return str;
		}
	}
	public void assignShape(String key, String shape) {
		mappings.put(key, shape);
	}
	public String[] getShapeList() {
		return shapeList;
	}
}
